#ifndef __CRYPT_MD5_H
#define __CRYPT_MD5_H

#define F1( x, y, z ) (z ^ (x & (y ^ z)))
#define F2( x, y, z ) F1( z, x, y )
#define F3( x, y, z ) (x ^ y ^ z)
#define F4( x, y, z ) (y ^ (x | ~z))

/* This is the central step in the MD5 algorithm. */
#define MD5STEP( f, w, x, y, z, data, s )  ( w += f( x, y, z ) + data,  w = w << s | w >> (32 - s),  w += x )

typedef struct tagMD5_CTX
{
    unsigned int i[2];
    unsigned int buf[4];
    unsigned char in[64];
    unsigned char digest[16];
} MD5_CTX;

void MD5Init( MD5_CTX *ctx );

void MD5Update( MD5_CTX *ctx, const unsigned char *buf, unsigned int len );

void MD5Final( MD5_CTX *ctx );

#endif
