#include "listviewtooltip.h"

ListViewToolTip::ListViewToolTip(UsersList* parent): QToolTip(parent->viewport()), listView(parent)
{
}

void ListViewToolTip::maybeTip(const QPoint& p)
{
    if (!listView)
	return;
    
    const QListViewItem* item = listView->itemAt(p);
    if (!item)
	return;
    
    const QRect itemRect = listView->itemRect(item);
    if (!itemRect.isValid())
	return;
    
    const int col = listView->header()->sectionAt(p.x());
    if (col == -1)
	return;
    
    const QRect headerRect = listView->header()->sectionRect(col);
    if (!headerRect.isValid())
	return;
    
    const QRect cellRect(headerRect.left(), itemRect.top(), headerRect.width(), itemRect.height());
    
    QString tipStr;
    tipStr = listView->getToolTip(item->text(0));
    
    tip(cellRect, tipStr);
}
