/***************************************************************************
                          messageedit.cpp  -  description
                             -------------------
    begin                : Wed Dec 22 21:10:00 EST 2004
    copyright            : (C) 2004-2006 by Sergey Litvinov
    email                : linch@adsl.by
 ***************************************************************************/

/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  		   *
 *   it under the terms of the GNU General Public License as published by  		   *
 *   the Free Software Foundation; either version 2 of the License, or     		   *
 *  (at your option) any later version.                                   				   *
 ***************************************************************************/

#include "messageedit.h"
#include "chatline.h"

MessageEdit::MessageEdit(QWidget *parent, const char *name): QTextEdit(parent, name)
{
    setTextFormat(Qt::PlainText);
    setWrapPolicy(QTextEdit::AtWordOrDocumentBoundary);
}

MessageEdit::~MessageEdit()
{
}

void MessageEdit::keyPressEvent(QKeyEvent *e)
{    
    emit keypressed(e->key());
    
    if ((e->key() == Qt::Key_Backspace) && (e->state() == Qt::ControlButton)) 
    {
	int para, index;
	getCursorPosition (&para, &index);
	ChatLine *c = new ChatLine(this, "c");
	QString txt = this->selectedText();
	if (!txt.isEmpty()) 
	    this->insert(c->convertMsg(txt));
	else 
	    this->setText(c->convertMsg(this->text()));
	setCursorPosition(para, index);
	return e->accept();
    }
    QTextEdit::keyPressEvent(e);
}
