/****************************************************************************
                          sendform.ui.h  -  description
                             -------------------
    begin                : Sat May 6 14:43:12 EST 2006
    copyright            : (C) 2004-2007 by Sergey Litvinov
    email                : linch@adsl.by
 ****************************************************************************/

/****************************************************************************
 *                                                                         					   		*
 *   This program is free software; you can redistribute it and/or modify  		   	*
 *   it under the terms of the GNU General Public License as published by  		   	*
 *   the Free Software Foundation; either version 2 of the License, or     		   	*
 *   (at your option) any later version.                                   				   	*
 *                                                                         					   		*
 ****************************************************************************/
	
void SendForm::setup(const QString &r, const QString &fpath, Q_ULONG s)
{
    setWFlags(Qt::WDestructiveClose | getWFlags());
    setCaption(r + tr(" <- file sending"));
    FileNameLabel->setText(fpath);
    FileSizeLabel->setText(Conversions::bytes2str(s));
}

void SendForm::updateProgressBar(Q_UINT32 progress)
{
    FileProgress->setProgress(progress);
}

void SendForm::closeEvent(QCloseEvent *event)
{
    emit cancel();
}

void SendForm::setAction(const QString& act)
{
    ActionLabel->setText(act);
}

void SendForm::setFileName(const QString& fpath)
{
    FileNameLabel->setText(fpath);
}

void SendForm::setFileSize(Q_ULONG fsize)
{
    FileSizeLabel->setText(Conversions::bytes2str(fsize));
}

void SendForm::setCurrentFileNumber(Q_ULONG n, Q_ULONG t)
{
    FileNumberLabel->setText('[' + QString::number(n) + '/' + QString::number(t) + ']');   
}
