/***************************************************************************
                          settingsdlg.ui.h  -  description
                             -------------------
    begin                : Sat Jan 22 18:15:04 EST 2005
    copyright            : (C) 2004-2007 by Sergey Litvinov
    email                : linch@adsl.by
 ***************************************************************************/

/***************************************************************************
 *  This program is free software; you can redistribute it and/or modify	                                              *
 *   it under the terms of the GNU General Public License as published by                                          *
 *   the Free Software Foundation; either version 2 of the License, or                                                  *
 *   (at your option) any later version.                                                                                                          *
 ***************************************************************************/

#include "xxxprotocol.h"
#include "global.h"
#include <qdir.h>
#include <qfiledialog.h>
#include <qfileinfo.h>
#include <qdatastream.h>
#include <qfontdialog.h>
#include <qpopupmenu.h>
//#include <iostream>

enum {
   CHN_OBJ = 0,
   USR_OBJ,
   NICK_OBJ,
   CHATLINE_OBJ
};

enum {
    CHANNELS_LIST = 1,
    BCAST_LIST
};

void SettingsDlg::init()
{
    OptionsView->header()->hide();
}

void SettingsDlg::setupCommonListOptions()
{
    CommonList->header()->hide();
    lvi1 = new QListViewItem(CommonList, tr("Basic options"));
    lvi1->setPixmap(0, QPixmap::fromMimeSource("settings.png"));
    
    lvi2 = new QCheckListItem(CommonList, tr("Show private messages contents on channel:"), QCheckListItem::RadioButtonController );
    lvi2->setPixmap(0, QPixmap::fromMimeSource("chnlalert.png"));
    
    lvi3 = new QCheckListItem(CommonList, tr("Private messages actions"), QCheckListItem::RadioButtonController );
    lvi3->setPixmap(0, QPixmap::fromMimeSource("prvnormal.png"));

    lvi4 = new QCheckListItem(CommonList, tr("Time stamp type"), QCheckListItem::RadioButtonController );
    lvi4->setPixmap(0, QPixmap::fromMimeSource("clock.png"));
    
    lvi5 = new QListViewItem(CommonList, tr("System messages"));
    lvi5->setPixmap(0, QPixmap::fromMimeSource("sysmsg.png"));
    
    lvi6 = new QListViewItem(CommonList, tr("Information messages"));
    lvi6->setPixmap(0, QPixmap::fromMimeSource("info.png"));
    
    lvi7 = new QCheckListItem(CommonList, tr("Automatic updating of the user's list"), QCheckListItem::RadioButtonController );    
    lvi7->setPixmap(0, QPixmap::fromMimeSource("refresh.png"));
    
    lvi8 = new QListViewItem(CommonList, tr("Bulletin board"));
    lvi8->setPixmap(0, QPixmap::fromMimeSource("boardnormal.png"));
    
    uColorsBox = new QCheckListItem(lvi1, tr("Use users colors"), QCheckListItem::CheckBox );
    infoACKBox = new QCheckListItem(lvi1, tr("Answer on information requests"),  QCheckListItem::CheckBox );
    restoreStatusBox = new QCheckListItem(lvi1, tr("Restore status on start"), QCheckListItem::CheckBox );
    startMinBox = new QCheckListItem(lvi1, tr("Start minimized"), QCheckListItem::CheckBox );
    raBox = new QCheckListItem(lvi1, tr("Send chat window state to others"), QCheckListItem::CheckBox );
    sendChListBox = new QCheckListItem(lvi1, tr("Send channels list to others"), QCheckListItem::CheckBox );
    legacyStyleBox = new QCheckListItem(lvi1, tr("Legacy style of the user's list update"), QCheckListItem::CheckBox );

    systrayNotify = new QCheckListItem(lvi1, tr("System tray icon notify"), QCheckListItem::CheckBox );
  
    massMessBox = new QCheckListItem(lvi2, tr("Apply for broadcast messages too"), QCheckListItem::CheckBox );
    pvtContNotShow = new QCheckListItem(lvi2, tr("Don't show"), QCheckListItem::RadioButton);
    pvtContMainShow =  new QCheckListItem(lvi2, tr("#Main"), QCheckListItem::RadioButton);
    pvtContCurrShow =  new QCheckListItem(lvi2, tr("Current"), QCheckListItem::RadioButton);
    
    popupBox = new QCheckListItem(lvi3, tr("Show popup private messages"), QCheckListItem::CheckBox );
    bMessBox = new QCheckListItem(lvi3, tr("Show broadcast messages"), QCheckListItem::CheckBox );
    pvtShowNormal = new QCheckListItem(lvi3, tr("Show normal"), QCheckListItem::RadioButton);
    pvtShowMinimized = new QCheckListItem(lvi3, tr("Show minimized"), QCheckListItem::RadioButton);
    pvtShowOnTop = new QCheckListItem(lvi3, tr("Show on top"), QCheckListItem::RadioButton);
    
    timeStampWithoutSeconds = new QCheckListItem(lvi4, tr("Use [hh:mm]"), QCheckListItem::RadioButton);
    timeStampWithSeconds = new QCheckListItem(lvi4, tr("Use [hh:mm:ss]"), QCheckListItem::RadioButton);
    
    JLMsgShow = new QCheckListItem(lvi5, tr("Join/Leave messages"), QCheckListItem::CheckBox );
    StatusMsgShow = new QCheckListItem(lvi5, tr("Status change messages"), QCheckListItem::CheckBox );
    NickChangeMsgShow = new QCheckListItem(lvi5, tr("Nick/Avatar change messages"), QCheckListItem::CheckBox );
    FileMsgShow = new QCheckListItem(lvi5, tr("File send/receive messages"), QCheckListItem::CheckBox );
    InfoReqMsgShow = new QCheckListItem(lvi5, tr("Information requests messages"), QCheckListItem::CheckBox );
    MsgACKShow =  new QCheckListItem(lvi5, tr("Private messages confirmations"), QCheckListItem::CheckBox );
    
    InfoAckOnChannelShow = new QCheckListItem(lvi6, tr("Duplicate user information dialog contents on channel"), QCheckListItem::CheckBox );
    TopicChangesShow =  new QCheckListItem(lvi6, tr("Topic change messages"), QCheckListItem::CheckBox );
    
    autoUpdateEnable =  new QCheckListItem(lvi7, tr("Enabled. Interval: ") + QString::number(settings->getAutoUpdateInterval()) + tr(" s") , QCheckListItem::RadioButton);    
    autoUpdateDisable = new QCheckListItem(lvi7, tr("Disabled"), QCheckListItem::RadioButton);
    
    boardEnabled = new QCheckListItem(lvi8, tr("Board enabled"), QCheckListItem::CheckBox );
    requestFromAuthorsOnly = new QCheckListItem(lvi8, tr("Request from authors only"), QCheckListItem::CheckBox );
    
    bMessBox->setOn(settings->getAllowMass());
    uColorsBox->setOn(settings->getUseUsersColors());
    infoACKBox->setOn(settings->getInfoACK());
    restoreStatusBox->setOn(settings->getKeepStatus());
    startMinBox->setOn(settings->getStartMin());
    raBox->setOn(settings->getShowRA());
    sendChListBox->setOn(settings->getSendChList());
    popupBox->setOn(settings->getShowPopups());
    legacyStyleBox->setOn(settings->getLegacyStyle());
    boardEnabled->setOn(settings->isBoardEnabled());
    requestFromAuthorsOnly->setOn(settings->requestFromAuthorsOnly());
    systrayNotify->setOn(settings->isSystrayNotifyEnabled());

    massMessBox->setOn(settings->getShowMassOnChannel());
    if (settings->getPrivMsgAction() == 0) pvtContNotShow->setOn(true);
    else if (settings->getPrivMsgAction() == 1) pvtContMainShow->setOn(true);
    else if (settings->getPrivMsgAction() == 2) pvtContCurrShow->setOn(true);
    
    if (settings->getPrivShowAction() == 0) pvtShowNormal->setOn(true);
    else if (settings->getPrivShowAction() == 1) pvtShowMinimized->setOn(true);
    else if (settings->getPrivShowAction() == 2) pvtShowOnTop->setOn(true);
    
    if (settings->getTimeStampWithSeconds()) timeStampWithSeconds->setOn(true);
    else timeStampWithoutSeconds->setOn(true);
    
    if (settings->getAutoUpdate()) autoUpdateEnable->setOn(true);
    else autoUpdateDisable->setOn(true);
    
    JLMsgShow->setOn(settings->getSystemMsgShow() & JOIN_LEAVE_SHOW);
    StatusMsgShow->setOn(settings->getSystemMsgShow() & STATUS_SHOW);
    NickChangeMsgShow->setOn(settings->getSystemMsgShow() & NICK_CHANGE_SHOW);
    FileMsgShow->setOn(settings->getSystemMsgShow() & FILE_MSG_SHOW);
    InfoReqMsgShow->setOn(settings->getSystemMsgShow() & INFO_REQ_SHOW);
    MsgACKShow->setOn(settings->getSystemMsgShow() & MSG_ACK_SHOW);
    InfoAckOnChannelShow->setOn(settings->getSystemMsgShow() & INFO_ACK_SHOW);
    TopicChangesShow->setOn(settings->getSystemMsgShow() & TOPIC_CHANGES_SHOW);
    
    lvi1->setOpen(true);
    lvi2->setOpen(true);
    lvi3->setOpen(true);
    lvi4->setOpen(true);
    lvi5->setOpen(true);
    lvi6->setOpen(true);
    lvi7->setOpen(true);
    lvi8->setOpen(true);
}

void SettingsDlg::setup(Settings *s, int page)
{
    settings = s;
 
    QString port;
    QString tmp;
    QStringList channels, blist;
	 
    delmenu = new QPopupMenu(channelsList);
    delmenu->insertItem(tr("Delete"), 1);
    connect(delmenu, SIGNAL(activated(int)), this, SLOT(menuAction(int)));

    port = port.setNum(settings->getPort());
     
    OptionsPage->raiseWidget ( page );
     
    NowPlayingBox->setChecked(settings->getNowPlaying());
    amarokBox->setChecked(settings->getUseAmaroK());
    NPFileEdit->setText(settings->getNPFile());
    if (!settings->getNowPlaying()) NPFrame->setEnabled(false);
    if (settings->getUseAmaroK()) NPFileEdit->setEnabled(false);
    
    if (settings->getUseMulticast())
    {
	CommunicationGroup->setButton(1);
	CommunicationGroup_clicked(1);
    }
    else
    {
	CommunicationGroup->setButton(0);
	CommunicationGroup_clicked(0);
    }
    
    blist = QStringList::split(",", settings->getBCastAddress());
    bcastList->insertStringList(blist);
    
//    BcastEdit->setText(settings->getBCastAddress());
    McastEdit->setText(settings->getMulticastGroup());
    PortEdit->setText(port);
    InterfaceList->insertStringList(settings->getIFNames());
    InterfaceList->setCurrentText(settings->getIFbyIP(settings->getIP()));
    ttlSpinBox->setValue(settings->getTTL());
    
	usersList->setPaletteBackgroundColor(settings->getUsersListBackColor());
	usersList->setPaletteForegroundColor(settings->getUsersListTextColor());
	nickEdit->setPaletteBackgroundColor(settings->getNickEditBackColor());
	nickEdit->setPaletteForegroundColor(settings->getNickEditTextColor());
	chatLineEdit->setPaletteBackgroundColor(settings->getChatLineEditBackColor());
	chatLineEdit->setPaletteForegroundColor(settings->getChatLineEditTextColor());
	
	OwnColor->setColor(settings->getOwnColor());
	UsersColor->setColor(settings->getUsersColor());
	PrivateColor->setColor(settings->getPrivateColor());
	SystemColor->setColor(settings->getSystemColor());
	NotifyColor->setColor(settings->getNotifyColor());
	JoinLeaveColor->setColor(settings->getJoinLeaveColor());
	
	connect(TextColor, SIGNAL(colorSelected(const QColor &)), this, SLOT(textColorChanged(const QColor &)));
	connect(BackGroundColor, SIGNAL(colorSelected(const QColor &)), this, SLOT(backColorChanged(const QColor &)));
	
	channelView->setPaletteBackgroundColor(settings->getBackgroundColor());
	channelView_clicked(0, 0);
    
    chatFont = settings->getChatFont();
    usersListFont = settings->getUsersListFont();
    editLineFont = settings->getEditLineFont();
    
    fontsUpdate();
    
    AwayMessage->setText(settings->getAwayAnswer());
    DNDMessage->setText(settings->getDNDAnswer());
    OfflineMessage->setText(settings->getOfflineAnswer()); 
    
    datapath = QString(DATADIR);
    
    updateAvatarsList();
	 
    QDir d(datapath + "tr/");
    d.setFilter( QDir::Files );
    d.setNameFilter("*.qm");

    for (uint i = 0; i < d.count(); i++ )
	LocalizeBox->insertItem(d[i]);
    LocalizeBox->setCurrentText(settings->getLocal());
    
    if (settings->getGender() == GENDER_MALE)
	MaleButton->setChecked(true);
    else 
	FemaleButton->setChecked(true);
    
    pixname = settings->getUserPixmap();
    updateAvatarPixmap(pixname);
    
    nicksmap.clear();
    QStringList lastnicks = QStringList::split(":", settings->getLastNicks(), true);
    if (lastnicks.count() & 0x01) lastnicks.append("0male.png");
    for(uint i = 0; i < lastnicks.count(); i += 2)
    {
	lastnicks[i].replace(QChar(':'), "_" );
	nicksmap.insert(lastnicks[i], lastnicks[i + 1]);
	NickEdit->insertItem(lastnicks[i]);
    }
    NickEdit->setCurrentText(settings->getNick());
    
    openChannelsBox->setChecked(settings->getStartChannels());
    setupCommonListOptions();
    MaxLinesCount->setValue(settings->getMaxLinesCount());
    AutoAwayMinutes->setValue(settings->getAwayLimit() / 60);
    
#ifdef WIN32
    NASButton->setText(tr("Sound card"));
#endif
    switch (settings->getSoundType())
    {
	case Sound::NoSound: 
	    NoSoundButton->setChecked(true);
	    break;
	case Sound::PCSpeaker: 
	    PCSpeakerButton->setChecked(true);
	    break;
	case Sound::NAS: 
	    NASButton->setChecked(true);
	    break;
	case Sound::Command:
	    ExtCmdButton->setChecked(true);
	    CommandLine->setDisabled(false);
	    break;
	default: 
	    PCSpeakerButton->setChecked(true); 
	    break;
    }
    CommandLine->setText(settings->getPlayCommand());
    for (uint i = 0; i < Sound::Dummy; i++)
    {
	snd[i] = settings->getSampleFileName(static_cast<Sound::Sfx>(i));
	sndp[i] = settings->getSampleEnabled(static_cast<Sound::Sfx>(i));
    }
    
    SoundsList->setSelected(0, true);
    
    channels = QStringList::split(",", settings->getChannelsList());
    channelsList->insertStringList(channels);
    
    OSEdit->setText(settings->getUserOS());
    ClientEdit->setText(settings->getClientName());
    
    webBrowserLine->setText(settings->getWebBrowser());
    SMBBrowserLine->setText(settings->getSMBBrowser());
    eMailClientLine->setText(settings->getEmailClient());
    FTPClientLine->setText(settings->getFTPClient());
    
    HistoryEdit->setText(settings->getHistoryFilePath());
    MaxHistSizeBox->setValue(settings->getMaxHistSize());
    
    DownloadEdit->setText(settings->getDownloadPath());
    MaxAvatarSizeBox->setValue(settings->getMaxAvatarSize());
    AcceptBox->setChecked(settings->getAcceptWOPrompt());
    senderFolderBox->setChecked(settings->getCreateSenderFolder());
    int selected = 0;
    QTextCodec *codec;
    const QString utf("UTF-8");
    
    for (int i = 0; codec = QTextCodec::codecForIndex(i); i++)
    {
	if (codec->name() != utf)
	{
	    CharacterEncodingBox->insertItem(codec->name());
	    if (strcmp(codec->name(), settings->getEncoding().latin1()) == 0)
		selected = i;
	}
    }
    CharacterEncodingBox->setCurrentItem(selected);
    UseUnicodeBox->setChecked(settings->getUseUTF());
    autoupdateinterval  = settings->getAutoUpdateInterval();
    checkInterval(autoupdateinterval);
}

void SettingsDlg::updateAvatarsList()
{
    AvatarsList->clear();
    AvatarsList->insertItem(QPixmap::fromMimeSource("default.png"), tr("Default"));
    QDir d(QDir::homeDirPath() + "/.trix/avatars/");
    d.setFilter(QDir::Files);
    d.setNameFilter("*.png *.jpeg *.jpg *.gif *.xbm *.xpm *.bmp");
    for (uint i = 0; i < d.count(); i++ )
	AvatarsList->insertItem(QPixmap::fromMimeSource(d[i]), d[i]);

    d = QDir(datapath + "avatars/");
    d.setFilter(QDir::Files);    
    for (uint i = 0; i < d.count(); i++ )
	AvatarsList->insertItem(QPixmap::fromMimeSource(d[i]), d[i]);  
}

void SettingsDlg::fontsUpdate()
{
    ChatFontLabel->setFont(chatFont);
    UsersListFontLabel->setFont(usersListFont);
    EditLineFontLabel->setFont(editLineFont);
    ChatFontLabel->setText(chatFont.family() + ",  " + QString::number(chatFont.pointSize()) + "pt");
    UsersListFontLabel->setText(usersListFont.family() + ",  " + QString::number(usersListFont.pointSize()) + "pt");
    EditLineFontLabel->setText(editLineFont.family() + ",  " + QString::number(editLineFont.pointSize()) + "pt");
}

void SettingsDlg::chatFontButtonClicked()
{
    bool ok;
    QFont f = QFontDialog::getFont( &ok, chatFont );
    if ( ok ) 
    {
	chatFont = f;
	fontsUpdate();
    }
}

void SettingsDlg::usersListFontButtonClicked()
{
    bool ok;
    QFont f = QFontDialog::getFont( &ok, usersListFont );
    if ( ok ) 
    {
	usersListFont = f;
	fontsUpdate();
    }
}

void SettingsDlg::editLineFontButtonClicked()
{
    bool ok;
    QFont f = QFontDialog::getFont( &ok, editLineFont );
    if ( ok ) 
    {
	editLineFont = f;
	fontsUpdate();
    }
}

void SettingsDlg::soundEventSelected(int index)
{
    SoundFileEdit->setText(snd[index]);
    SoundFileEdit->setDisabled(!sndp[index]);
    SoundBox->setChecked(sndp[index]);
}

void SettingsDlg::browseSoundClicked()
{
    QString start = SoundFileEdit->text();
    if (start.isEmpty())
	start = QString(QString(DATADIR) + "snd/");
    QString selected = QFileDialog::getOpenFileName(start, tr("Sounds (*.wav);;All files (*.*)"), this, 0, tr("Select sound file"));
    if (!selected.isNull())
    {
	SoundFileEdit->setText(selected);
	snd[SoundsList->currentItem()] = selected;
    }
}

void SettingsDlg::soundSystemClicked(int index)
{
    CommandLine->setDisabled(index!=3);
}

void SettingsDlg::playFlagClicked(bool state)
{
    SoundFileEdit->setEnabled(state);
    BrowseButton->setEnabled(state);
    sndp[SoundsList->currentItem()] = state;
}

void SettingsDlg::changeBox( QListViewItem *it )
{
    OptionsBox->setTitle(it->text(0));
    if (it->text(0) == tr("Network options")) OptionsPage->raiseWidget ( 0 );
    if (it->text(0) == tr("Individual options")) OptionsPage->raiseWidget ( 1 );
    if (it->text(0) == tr("Fonts setup")) OptionsPage->raiseWidget ( 2 );
    if (it->text(0) == tr("Colors setup")) OptionsPage->raiseWidget ( 12 );
    if (it->text(0) == tr("Mode/Autoanswers")) OptionsPage->raiseWidget ( 3 );
    if (it->text(0) == tr("Common options")) OptionsPage->raiseWidget ( 4 );
    if (it->text(0) == tr("Sound system")) OptionsPage->raiseWidget ( 5 );
    if (it->text(0) == tr("Sounds")) OptionsPage->raiseWidget ( 6 );
    if (it->text(0) == tr("Localization")) OptionsPage->raiseWidget ( 7 );
    if (it->text(0) == tr("Channels")) OptionsPage->raiseWidget( 8 );
    if (it->text(0) == tr("External programs")) OptionsPage->raiseWidget( 9 );
    if (it->text(0) == tr("History")) OptionsPage->raiseWidget( 10 );
    if (it->text(0) == tr("File transfer")) OptionsPage->raiseWidget( 11 );
    if (it->text(0) == tr("Client information")) OptionsPage->raiseWidget( 13 );
}

void SettingsDlg::closeEvent(QCloseEvent *event)
{
    AcceptChanges();
    event->accept();
}

void SettingsDlg::AcceptChanges()
{
    bool c = false;
    QString port = PortEdit->text();
    QString n = NickEdit->currentText();
    QStringList lastnicks;
    QStringList channels, blist;
    
    n.replace(QChar(':'), "_" );
    
    settings->setShowPopups(popupBox->isOn());
    settings->setMaxLinesCount(MaxLinesCount->value());
    settings->setAwayLimit(AutoAwayMinutes->value() * 60);
    settings->setSendChList(sendChListBox->isOn());
    settings->setNowPlaying(NowPlayingBox->isOn());
    settings->setAllowMass(bMessBox->isOn());
    settings->setShowMassOnChannel(massMessBox->isOn());
    settings->setUseUsersColors(uColorsBox->isOn());
    settings->setInfoACK(infoACKBox->isOn());
    settings->setKeepStatus(restoreStatusBox->isOn());
    settings->setStartMin(startMinBox->isOn());
    settings->setShowRA(raBox->isOn());
    settings->setStartChannels(openChannelsBox->isOn());
    settings->setNPFile(NPFileEdit->text());
    settings->setUseAmaroK(amarokBox->isOn());
    settings->setCreateSenderFolder(senderFolderBox->isOn());
    settings->setBoardEnabled(boardEnabled->isOn());
    settings->setRequestFromAuthorsOnly(requestFromAuthorsOnly->isOn());
    settings->setSystrayNotifyEnabled(systrayNotify->isOn());
    if (!n.isEmpty()) settings->setNick(n);
    
    for (uint i = 0; i < bcastList->count(); i ++)
	blist.append(bcastList->text(i));

    c = settings->setBCastAddress(blist.join(","));
    c |= settings->setMulticast(McastEdit->text());
    c |= settings->setPort(port.toUInt());
    c |= settings->setTTL(ttlSpinBox->value());
    c |= settings->setUseMulticast(MCastButton->isOn());
    c |= settings->setIP(settings->getIPbyIF(InterfaceList->currentText()));
	
    settings->setColors(channelView->paletteBackgroundColor(), OwnColor->color(), UsersColor->color(), PrivateColor->color(),  SystemColor->color(), NotifyColor->color(), JoinLeaveColor->color());
    settings->setUsersListBackColor(usersList->paletteBackgroundColor());
    settings->setUsersListTextColor(usersList->paletteForegroundColor());
    settings->setNickEditBackColor(nickEdit->paletteBackgroundColor());
    settings->setNickEditTextColor(nickEdit->paletteForegroundColor());
    settings->setChatLineEditBackColor(chatLineEdit->paletteBackgroundColor());
    settings->setChatLineEditTextColor(chatLineEdit->paletteForegroundColor());
	
    settings->setFonts(chatFont, usersListFont, editLineFont);
    settings->setAutoanswers(DNDMessage->text(), AwayMessage->text(), OfflineMessage->text());
    settings->setUserPixmap(pixname);
    
    settings->setLocal(LocalizeBox->currentText());        
    
    if (MaleButton->isChecked()) 
	settings->setGender('0');
    else 
	settings->setGender('1');
    
    settings->setPlayCommand(CommandLine->text());
    settings->setSoundType(static_cast<Sound::SoundType>(SoundGroup->id(SoundGroup->selected())));
    for (uint i = 0; i < Sound::Dummy; i++)
    {
	settings->setSampleFileName(static_cast<Sound::Sfx>(i), snd[i]);
	settings->setSampleEnabled(static_cast<Sound::Sfx>(i), sndp[i]);
    }
    for (uint i = 0; i < channelsList->count(); i ++)
	channels.append(channelsList->text(i));
		 
    settings->setChannelsList(channels.join(","));
	 
    settings->setWebBrowser(webBrowserLine->text());
    settings->setSMBBrowser(SMBBrowserLine->text());
    settings->setEmailClient(eMailClientLine->text());
    settings->setFTPClient(FTPClientLine->text());

    settings->setUserOS(OSEdit->text());
    settings->setClientName(ClientEdit->text());
    
    settings->setHistoryFilePath(HistoryEdit->text());
    settings->setMaxHistSize(MaxHistSizeBox->value());

    if (pvtContNotShow->isOn()) settings->setPrivMsgAction(0);
    else if (pvtContMainShow->isOn()) settings->setPrivMsgAction(1);
    else if (pvtContCurrShow->isOn()) settings->setPrivMsgAction(2);

    if (pvtShowNormal->isOn()) settings->setPrivShowAction(0);
    else if (pvtShowMinimized->isOn()) settings->setPrivShowAction(1);
    else if (pvtShowOnTop->isOn()) settings->setPrivShowAction(2);

     settings->setSystemMsgShow(JLMsgShow->isOn() | StatusMsgShow->isOn() << 1 | NickChangeMsgShow->isOn() << 2 | FileMsgShow->isOn() << 3 | InfoReqMsgShow->isOn() << 4 | MsgACKShow->isOn() << 5 | InfoAckOnChannelShow->isOn() << 6 | TopicChangesShow->isOn() << 7);
     
    settings->setTimeStampWithSeconds(timeStampWithSeconds->isOn());
    
    settings->setAutoUpdate(autoUpdateEnable->isOn());
    checkInterval(autoupdateinterval);
    settings->setAutoUpdateInterval(autoupdateinterval);

    settings->setLegacyStyle(legacyStyleBox->isOn());
    settings->setDownloadPath(DownloadEdit->text());
    settings->setMaxAvatarSize(MaxAvatarSizeBox->value());
    settings->setAcceptWOPrompt(AcceptBox->isChecked());

    c |= settings->setEncodingName(CharacterEncodingBox->currentItem() ? CharacterEncodingBox->currentText() : "");
    c |= settings->setUseUTF(UseUnicodeBox->isChecked());
    
    for (NicksMap::iterator it = nicksmap.begin(); it != nicksmap.end(); it++)
    {
	lastnicks.append(it.key());
	lastnicks.append(it.data());
    }
    settings->setLastNicks(lastnicks.join(":"));
    
    emit applySettings(c);
}

void SettingsDlg::applyAvatar()
{
    pixname = (AvatarsList->currentItem() > 0) ? AvatarsList->currentText() : "";
    updateAvatarPixmap(pixname);    
}

void SettingsDlg::updateAvatarPixmap(const QString &pname)
{
    UserPixmap->setPixmap(QPixmap::fromMimeSource(pname));
    nicksmap.insert(NickEdit->currentText(), QString(QChar((MaleButton->isChecked()) ? '0' : '1') + pixname));
    if (pname.isEmpty())
	UserPixmap->setPixmap((MaleButton->isChecked()) ? QPixmap::fromMimeSource("male.png") : QPixmap::fromMimeSource("female.png"));
}

void SettingsDlg::addChannelBtnClicked()
{
    if (!addChannelLine->text().isEmpty())
    {
	channelsList->insertItem(addChannelLine->text());
	addChannelLine->clear();
    }
}

void SettingsDlg::menuAction(int option)
{
    int i;
    switch(delobjectparent)
    {
    case CHANNELS_LIST:
	i = channelsList->currentItem();
	if (option == 1) 
	    channelsList->removeItem(i);
	break;
    case BCAST_LIST:
	i = bcastList->currentItem();
	if (option == 1) 
	    bcastList->removeItem(i);
	break;
    default: break;
    }
}

void SettingsDlg::destroy()
{
    delete delmenu;
}

void SettingsDlg::channelsList_contextMenuRequested( QListBoxItem *it, const QPoint & pos)
{
    delobjectparent = CHANNELS_LIST;
    delmenu->exec(pos);
}

void SettingsDlg::HistoryBrowseButton_clicked()
{
    QString start = HistoryEdit->text();
    if (start.isEmpty())
	start = QString(QDir::homeDirPath());    
    QFileDialog* fd = new QFileDialog(this, "Open file dialog", TRUE );
    fd->setFilter(tr("All files (*)"));
    fd->setMode( QFileDialog::AnyFile );
    fd->setSelection(start);
    if ( fd->exec() == QDialog::Accepted )
    {
	QString selected = fd->selectedFile();
	if (!selected.isNull())
	    HistoryEdit->setText(selected);
    }
}

void SettingsDlg::DownloadButton_clicked()
{
    QString start = DownloadEdit->text();
    if (start.isEmpty())
	start = QString(QDir::homeDirPath());
    QString selected = QFileDialog::getExistingDirectory(start, this, "Get download directory", tr("Choose a folder"), TRUE);
    if (!selected.isNull())
	DownloadEdit->setText(selected);
}


void SettingsDlg::AvatarAddButton_clicked()
{
    QString start = QDir::homeDirPath();
    
    QString selected = QFileDialog::getOpenFileName(start, tr("All Pixmaps (*.bmp;*.jpg;*.jpeg;*.png;*.xbm;*.xpm)"), this, 0, tr("Select image file"));
    if (!selected.isNull())
    {
		 Q_LONG buf;
		 QFile source(selected);
		 QFileInfo fi(selected);
		 QString fname = fi.fileName();
		 
		 QDir d(QDir::homeDirPath() + "/.trix/avatars/");
		 if (!d.exists()) 
		     d.mkdir(d.absPath());
		 
		 QFile target(QDir::homeDirPath() + "/.trix/avatars/" + fname);
		 if ((source.open (IO_ReadOnly)) && (target.open(IO_WriteOnly))) 
		 {
			 QDataStream srcstream(&source);
			 QDataStream trgstream(&target);
			 
			 while (!source.atEnd())
			 {
				 srcstream >> buf;
				 trgstream << buf;
			 }
			 
			 target.close();
			 source.close();
			 updateAvatarsList();
		 }
    }
}

void SettingsDlg::AvatarDeleteButton_clicked()
{
	if(AvatarsList->currentItem() != -1) 
	{
	    if (QMessageBox::question(
		    this,
		    tr("Delete the avatar"),
		    tr("Are you sure you wish to delete the avatar \"%1\"?")
		    .arg(AvatarsList->currentText()),
		    tr("&Yes"), tr("&No"),
		    QString::null, 0, 1) == 0)
	    {
		QString selected = AvatarsList->currentText();
		QFile file(QDir::homeDirPath() + "/.trix/avatars/" + selected);
		file.remove();
	    }
	}
	updateAvatarsList();
}

void SettingsDlg::genderChanged(int g)
{
    updateAvatarPixmap(pixname);
}

void SettingsDlg::CommunicationGroup_clicked( int t)
{
    addressLabel->setEnabled(BCastButton->isOn());
    BcastEdit->setEnabled(BCastButton->isOn());
    bcastList->setEnabled(BCastButton->isOn());
    
    multicastGroupLabel->setEnabled(!BCastButton->isOn());
    ttlLabel->setEnabled(!BCastButton->isOn());
    McastEdit->setEnabled(!BCastButton->isOn());
    ttlSpinBox->setEnabled(!BCastButton->isOn());
    TTLDefaultButton->setEnabled(!BCastButton->isOn());
}

void SettingsDlg::channelView_clicked(int para, int pos)
{
   specialColorsFrame->show();
   textFrame->hide();
   BackGroundColor->setColor(channelView->paletteBackgroundColor());
   channelView->setText(QString(tr("<font color=\"%1\">[hh:mm] User joins channel #Main (Active mode)</font><br><font color=\"%2\">[hh:mm] Sound signal from User received</font><br><font color=\"%3\">[hh:mm] Message from User received</font><br><font color=\"%4\">[hh:mm] Info on User:</font><br><font color=\"%5\">[hh:mm] &lt;You&gt;: Your own text</font><br><font color=\"%6\">[hh:mm] &lt;User&gt;: User text</font><br>")).arg(JoinLeaveColor->color().name()).arg(NotifyColor->color().name()).arg(PrivateColor->color().name()).arg(SystemColor->color().name()).arg(OwnColor->color().name()).arg(UsersColor->color().name()));
   curColorObject = CHN_OBJ;
}

void SettingsDlg::usersList_clicked( QListViewItem * it)
{
   specialColorsFrame->hide();
   textFrame->show();
   TextColor->setColor(usersList->paletteForegroundColor());
   BackGroundColor->setColor(usersList->paletteBackgroundColor());
   curColorObject = USR_OBJ;
}


void SettingsDlg::nickEdit_clicked(int para, int pos)
{
   specialColorsFrame->hide();
   textFrame->show();
   TextColor->setColor(nickEdit->paletteForegroundColor());
   BackGroundColor->setColor(nickEdit->paletteBackgroundColor());
   curColorObject = NICK_OBJ;
}


void SettingsDlg::chatLineEdit_clicked(int para, int pos)
{
   specialColorsFrame->hide();
   textFrame->show();
   TextColor->setColor(chatLineEdit->paletteForegroundColor());
   BackGroundColor->setColor(chatLineEdit->paletteBackgroundColor());
   curColorObject = CHATLINE_OBJ;
}

void SettingsDlg::specialColorChanged(const QColor &c)
{
   channelView_clicked(0, 0);
}

void SettingsDlg::textColorChanged(const QColor &c)
{
   switch(curColorObject)
   {
   case CHN_OBJ:
	  channelView->setPaletteForegroundColor(c);  
	  break;
   case USR_OBJ:
	  usersList->setPaletteForegroundColor(c);
	  break;
   case NICK_OBJ:
	  nickEdit->setPaletteForegroundColor(c);
	  break;
   case CHATLINE_OBJ:
	  chatLineEdit->setPaletteForegroundColor(c);
	  break;
   default:break;
   }
}

void SettingsDlg::backColorChanged(const QColor &c)
{
   switch(curColorObject)
   {
   case CHN_OBJ:
	  channelView->setPaletteBackgroundColor(c);	  
	  break;
   case USR_OBJ:
	  usersList->setPaletteBackgroundColor(c);
	  break;
   case NICK_OBJ:
	  nickEdit->setPaletteBackgroundColor(c);
	  break;
   case CHATLINE_OBJ:
	  chatLineEdit->setPaletteBackgroundColor(c);
	  break;
   default:break;
   }
}

void SettingsDlg::NickEdit_activated( const QString & nicktext)
{
    if(!nicktext.isEmpty())
    {
	QString n = nicktext;
	n.replace(QChar(':'), "_");
	if (nicksmap.contains(n))
	{
	    QString tmp = nicksmap[n];
	    if (QChar(tmp[0]) == QChar(GENDER_MALE))
		MaleButton->setChecked(true);
	    else 
		FemaleButton->setChecked(true);
	    pixname = tmp.right(tmp.length() - 1);
	    updateAvatarPixmap(pixname);
	}
	else
	{
	    nicksmap.insert(n, QString(QChar((MaleButton->isChecked()) ? '0' : '1') + pixname));
	}
    }
}


void SettingsDlg::NowPlayingBox_toggled( bool n )
{
    NPFrame->setEnabled(n);
}


void SettingsDlg::amarokBox_toggled( bool a )
{
    NPFileEdit->setEnabled(!a);
    npLabel->setEnabled(!a);
    npBrowseBtn->setEnabled(!a);
}

void SettingsDlg::TTLDefaultButton_clicked()
{
    ttlSpinBox->setValue(settings->getDefTTL());
}

void SettingsDlg::PortDefaultButton_clicked()
{
    PortEdit->setText(QString::number(settings->getDefPort()));
}

void SettingsDlg::CommonList_doubleClicked( QListViewItem *it )
{
    if (it->text(0).startsWith(tr("Enabled. Interval: ")))
    {
	EnterForm *ef = new EnterForm(this, "Enter data", Qt::WDestructiveClose|Qt::WStyle_Dialog);
	ef->setCaptionText(tr("Enter update interval:"));
	ef->setEditText(QString::number(autoupdateinterval));
	connect(ef, SIGNAL(ok(const QString &)), this, SLOT(intervalChanged(const QString &)));
	ef->show();
    }
}

void SettingsDlg::intervalChanged(const QString &interval)
{
    autoupdateinterval = interval.toInt();
    checkInterval(autoupdateinterval);
}

void SettingsDlg::checkInterval(int i)
{
    if (i < 0) autoupdateinterval = 0;
   
    if (autoupdateinterval == 0) autoUpdateDisable->setOn(true);
    
    autoUpdateEnable->setText(0, tr("Enabled. Interval: ") + QString::number(autoupdateinterval) + tr(" s"));
}

void SettingsDlg::BcastEdit_returnPressed()
{
    if (!BcastEdit->text().isEmpty())
    {
	QHostAddress addr;
	addr.setAddress(BcastEdit->text());
	if (addr.isIPv4Address())
	{
	    bcastList->insertItem(addr.toString());
	    BcastEdit->clear();
	}
    }
}

void SettingsDlg::bcastList_contextMenuRequested( QListBoxItem *, const QPoint & pos)
{
    delobjectparent = BCAST_LIST;
    delmenu->exec(pos);
}

void SettingsDlg::npBrowseBtn_clicked()
{
    QString start = NPFileEdit->text();
    if (start.isEmpty())
	start = QDir::homeDirPath();
    QString selected = QFileDialog::getOpenFileName(start, tr("Text (*.txt);;All files (*.*)"), this, 0, tr("Select file"));
    if (!selected.isNull())
	NPFileEdit->setText(selected);
}
