#include "topic.h"
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>

TopicForm::TopicForm(QWidget *parent, const QString &name, const QString &channel, const QString &topic): QWidget(parent, NULL, Qt::WDestructiveClose | Qt::WShowModal | Qt::WStyle_Dialog)
{
	this->channel = channel;
	setCaption(name + channel);
	
	l1 = new QVBoxLayout(this, 5, 6);
	topicline = new QLineEdit(topic, this);
	l1->addWidget(topicline);

	l2 = new QHBoxLayout(0, 0, 6);
	s1 = new QSpacerItem(40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);
	l2->addItem(s1);

	b_change = new QPushButton(tr("Accept"), this);
	l2->addWidget(b_change);

	b_cancel = new QPushButton(tr("Cancel"), this);
	l2->addWidget(b_cancel);
	l1->addLayout(l2);
	resize( QSize(400, 90).expandedTo(minimumSizeHint()) );
	
	b_change->setAccel(QKeySequence("Return"));
	b_cancel->setAccel(QKeySequence("Esc"));
	connect(b_change, SIGNAL(clicked()), this, SLOT(accept()));
	connect(b_cancel, SIGNAL(clicked()), this, SLOT(close()));
}

TopicForm::~TopicForm()
{
}

void TopicForm::accept()
{
	emit change(channel, topicline->text());
	close();
}
