#ifndef __USER_H
#define __USER_H

#include <stdlib.h>
#include <qhostaddress.h>
#include <qlistview.h>
#include <qpixmap.h>
#include <qimage.h>

class QPainter;

class User: public QListViewItem
{
    private:
	bool photo;
	char gender;
	char ractive;
	char status;
	int timer;
	QHostAddress ip;
	QPixmap userpixmap;
	QPixmap userpixmaptiny;
	QPixmap curpixmap;
	QString nick, tooltip, avatar, color, autoanswer;
  
	bool setGender(char g) { gender = g; return true; }
	bool setStatus(char s) { status = s; return true; }
	bool setRactive(char r) { ractive = r; return true; }
	bool setAvatar(const QString & a, bool p);
	bool setUserColor(const QString &c);
	bool setAutoanswer(const QString &a) { autoanswer = a; return true; }
	void setNick(const QString &n);
	bool setToolTip(const QString &t) { tooltip = t; return true; }
	bool resetTimer() { timer = 0; return true; }
	int incTimer() { return ++timer; }
	void generateTinyPixmap(int size);
    public:
	User(QListView *list, const QString &n, const QHostAddress &addr, char gend, const QString &fid, const QString &c);

	~User();

	char getGender() { return gender; }
	char getStatus() { return status; }
	char getRactive() { return ractive; }
	const QString &getNick() { return nick; }
	const QString &getAvatar() { return avatar; }
	const QString &getUserColor() { return color; }
	const QString &getAutoanswer() { return autoanswer; }
	bool AvatarIsAPhoto() { return photo; }
	const QString &getToolTip() { return tooltip; }
	const QHostAddress &getIP() { return ip; }
	void paintCell(QPainter *p, const QColorGroup &cg, int column, int width, int alignment);
	QImage& toGray(QImage &img);
	void updatePixmap();
	int height() const;
	
	friend class UsersList;
};

#endif
